import { it, assert, assertEq } from 'folktest'
import { concat } from '../..//src/function.js'
import { isIterable, iter } from '../..//src/list.js'

export const Functions = [
  it('concat', () => {
    assertEq(concat(1, []), [1])
    assertEq(concat([], 1), [1])
    assertEq(concat([2], [1]), [1, 2])
    const a = concat([2], iter([1]))
    assert(isIterable(a), 'concat([2], iter([1])) returned a non-iterable')
    assertEq([...a], [1, 2])

    const b = concat(iter([2]), [1])
    assert(isIterable(b), 'concat(iter([2]), [1]) returned a non-iterable')
    assertEq([...b], [1, 2])
  })
]

